include compress.inc

mstruc WIN32_FIND_DATA
    m dwFileAttributes
    m ftCreationTime,8
    m ftLastAccessTime,8
    m ftLastWriteTime,8
    m nFileSizeHigh
    m nFileSizeLow
    m dwReserved0
    m dwReserved1
    m cFileName,260
    m cAlternateFileName,14
mends

includelib kernel32.lib

LoadLibraryA proto :dword
GetProcAddress proto :dword, :dword

PAGE_READWRITE         =     4
MEM_COMMIT             = 01000h
MEM_RESERVE            = 02000h
MEM_RELEASE            = 08000h
GENERIC_READ           = 080000000h
GENERIC_WRITE          = 040000000h
FILE_SHARE_READ        = 1
FILE_SHARE_WRITE       = 2
FILE_FLAG_RANDOM_ACCESS    = 010000000h
CREATE_NEW             = 1
CREATE_ALWAYS          = 2
OPEN_EXISTING          = 3
OPEN_ALWAYS            = 4
FILE_BEGIN   = 0
FILE_CURRENT = 1
FILE_END     = 2
MB_ICONERROR   = 010h

.data
Log_FileHandle dd 0
Sys_LibKernel32 db "kernel32.dll",0
	db "CloseHandle",0
CloseHandle dd 0
	db "CreateFileA",0
CreateFileA dd 0
	db "ExitProcess",0
ExitProcess dd 0
	db "FindClose",0
FindClose dd 0
	db "FindFirstFileA",0
FindFirstFileA dd 0
	db "FindNextFileA",0
FindNextFileA dd 0
	db "GetFileSize",0
GetFileSize dd 0
	db "ReadFile",0
ReadFile dd 0
	db "SetFilePointer",0
SetFilePointer dd 0
	db "VirtualAlloc",0
VirtualAlloc dd 0
	db "VirtualFree",0
VirtualFree dd 0
	db "WriteFile",0
WriteFile dd 0
	db 0
		
Sys_LibUser32 db "user32.dll",0
	db "MessageBoxA",0
MessageBoxA dd 0
	db "wvsprintfA",0
wvsprintfA dd 0
	db 0
	
.code

Sys_MemClear proc Dest,
		  Count
mpush	eax, ecx, edi
mov	edi, [Dest]
mov	ecx, [Count]
xor	eax, eax
cld
rep	stosb
mpop	edi, ecx, eax
ret
Sys_MemClear endp

Sys_MemCopy proc Dest,
		 Src,
		 Count
mpush	ecx, esi, edi
mov	esi, [Src]
mov	edi, [Dest]
mov	ecx, [Count]
cld
rep	movsb
mpop	edi, esi, ecx
ret
Sys_MemCopy endp

Sys_StrLen proc String
mpush	ecx, esi
mov	esi, [String]
xor	eax, eax
@@1000:
mov	cl, [esi]
inc	eax
inc	esi
cmp	cl, 0
jne	@@1000
dec	eax
mpop	esi, ecx
ret
Sys_StrLen endp

Sys_StrCpy proc Dest,
		Src
mpush	eax, esi, edi
mov	esi, [Src]
mov	edi, [Dest]
@@1000:
mov	al, [esi]
inc	esi
mov	[edi], al
inc	edi
cmp	al, 0
jne	@@1000
mpop	edi, esi, eax
ret
Sys_StrCpy endp


Sys_vsprintf proc Dest,
		  FormatString,
		  pArgumentsList
mpush	ecx, edx
mcall	[wvsprintfA], [Dest], [FormatString], [pArgumentsList]
mpop	edx, ecx
ret
Sys_vsprintf endp

Sys_sprintf proc Dest,
		 FormatString
push	eax
lea	eax, [FormatString + 4]
mcall	Sys_vsprintf, [Dest], [FormatString], eax
pop	eax
ret
Sys_sprintf endp

Sys_LoadLibrary proc Library
pushad
mov	esi, [Library]
mcall	LoadLibraryA, esi
test	eax, eax
jz	@@fail
xchg	eax, ebx
mcall	Sys_StrLen, esi
lea	esi, [esi+eax+1]
@@1000:
mcall	Sys_StrLen, esi
test	eax, eax
jz	@@9000
lea	edi, [esi+eax+1]
mcall	GetProcAddress, ebx, esi
test	eax, eax
jz	@@fail
stosd
mov	esi, edi
jmp	@@1000
@@9000:
popad
ret
@@fail:
push	[Library]
pushstr "Sys_LoadLibrary(%s)"
call	Error
Sys_LoadLibrary endp

Error proc ErrorString 
local Buffer[256]:byte
lea	eax, [ErrorString+4]
push	eax
push	[ErrorString]
lea	eax, [Buffer]
push	eax
call	Sys_vsprintf
push	MB_ICONERROR
pushstr "y'a 1 erreur"
lea	eax, [Buffer]
push	eax
push	0
call	[MessageBoxA]
call	Sys_Release
Error endp

Sys_MemAlloc proc Count
mpush	ecx, edx
add	[Count], 4
mcall	[VirtualAlloc], 0, [Count], \
		(MEM_COMMIT+MEM_RESERVE), PAGE_READWRITE
mcall	Sys_MemClear, eax, [Count]
mpop	edx, ecx
ret
Sys_MemAlloc endp

Sys_MemFree proc Data
pushad
mov	eax, [Data]
test	eax, eax
jz	@@1000
mcall	[VirtualFree], eax, 0, MEM_RELEASE
@@1000:
popad
ret
Sys_MemFree endp

Sys_FileOpen proc FileName 
mpush 	ecx, edx
mcall 	[CreateFileA], [FileName],(GENERIC_READ+GENERIC_WRITE),\
	(FILE_SHARE_READ+FILE_SHARE_WRITE),\
	0,OPEN_EXISTING,\
	FILE_FLAG_RANDOM_ACCESS,0
cmp	eax, -1
jne	@@1000		
push	[FileName]	
pushstr "Sys_FileOpen(%s)"
call	Error
@@1000:	
mpop 	edx, ecx
ret
Sys_FileOpen endp

Sys_FileCreate proc FileName
mpush 	ecx, edx
mcall 	[CreateFileA], [FileName],(GENERIC_READ+GENERIC_WRITE),\
	(FILE_SHARE_READ+FILE_SHARE_WRITE),\
	0,CREATE_ALWAYS,\
	FILE_FLAG_RANDOM_ACCESS,0
cmp	eax, -1
jne	@@1000		
push	[FileName]	
pushstr "Sys_FileCreate(%s)"
call	Error
@@1000:	
mpop 	edx, ecx
ret
Sys_FileCreate endp
	
Sys_FileClose proc FileHandle
pushad
mcall	[CloseHandle], [FileHandle]
popad
ret
Sys_FileClose endp
	
Sys_FileRead proc FileHandle,
		  Dest,
		  Count
local tmp
pushad
lea	eax, [tmp]
mcall	[ReadFile], [FileHandle], [Dest], [Count], eax, 0
test	eax, eax
jnz	@@1000
pushstr "Sys_FileRead()"
call	Error
@@1000:
popad		
ret
Sys_FileRead endp

Sys_FileWrite proc FileHandle,
		   Src,
		   Count
local tmp
pushad
lea	eax, [tmp]
mcall	[WriteFile], [FileHandle], [Src], [Count], eax, 0
test	eax, eax
jnz	@@1000
pushstr "Sys_FileWrite()"
call	Error
@@1000:
popad		
ret
Sys_FileWrite endp

Sys_FileGetSize proc FileHandle
mpush	ecx, edx
mcall	[GetFileSize], [FileHandle], 0
mpop	edx, ecx
ret
Sys_FileGetSize endp

Sys_FileSeekBegin proc FileHandle,
		       Distance
pushad
mcall 	[SetFilePointer], [FileHandle], [Distance], 0, FILE_BEGIN
popad
ret
Sys_FileSeekBegin endp

Sys_FileExists proc FileName
mpush	ecx, edx
mcall	[CreateFileA], [FileName],0,0,0,\
		OPEN_EXISTING,FILE_FLAG_RANDOM_ACCESS,0
cmp	eax, -1
je	@@1000
mcall	Sys_FileClose, eax
xor	eax, eax
@@1000:
inc	eax
mpop	edx, ecx	
ret
Sys_FileExists endp

;OUT:EAX=Data
Sys_FileLoad proc FileName,
		  pFileSize
mpush	ecx, edx
mcall	Sys_FileOpen, [FileName]
xchg	eax, ecx
mcall	Sys_FileGetSize, ecx
mov	edx, [pFileSize]
mov	[edx], eax
xchg	eax, edx
mcall	Sys_MemAlloc, edx
mcall	Sys_FileRead, ecx, eax, edx
mcall	Sys_FileClose, ecx
mpop	edx, ecx
ret
Sys_FileLoad endp

Sys_FileSave proc FileName,
		  Data,
		  Count
pushad		  
mcall	Sys_FileCreate, [FileName]
xchg	eax, edx
mcall	Sys_FileWrite, edx, [Data], [Count]
mcall	Sys_FileClose, edx
popad
ret
Sys_FileSave endp

Sys_LogCreate proc 
pushstr "log.txt"
call	Sys_FileCreate
mov	[Log_FileHandle], eax
ret
Sys_LogCreate endp

Sys_LogPrintf proc LogString
local Buffer[256]:byte
mpush	eax, esi
lea	esi, [Buffer]
lea	eax, [LogString+4]
mcall	Sys_vsprintf, esi, [LogString], eax
mcall	Sys_StrLen, esi
mov	@[esi + eax], ((13 shl 0)+(10 shl 8))
add	eax, 2
mcall	Sys_FileWrite, [Log_FileHandle], esi, eax
mpop	esi, eax
ret
Sys_LogPrintf endp

Sys_LogRelease proc 
mcall	Sys_FileClose, [Log_FileHandle]
and	[Log_FileHandle], 0
ret
Sys_LogRelease endp

Sys_Create proc
mcall	Sys_LoadLibrary, offset Sys_LibKernel32
mcall	Sys_LoadLibrary, offset Sys_LibUser32
call	Sys_LogCreate
ret
Sys_Create endp

Sys_Release proc 
call	Sys_LogRelease
call	[ExitProcess]
Sys_Release endp

mstruc ALPH
	m Brother,2
	m Child,2
	m Character,1
	m Unused,3
mends 
CODE_CLEAR      =    256
CODE_EOI        =    257
MAX_CODE_SIZE   =     10
NO_CHILD	= CODE_CLEAR
NO_BROTHER	= CODE_EOI
		
; => eax : OutputSize
LZW_Compress proc OutputData,
		  InputData,
		  InputSize
local OutputSize,
	CodeSize,
	FreeCode, 
	MaxCode,
	CurrentCode,
	CurrentChar,
	BitShift,
	OutputDWord
pushad
mov	esi, [InputData]
mov	edi, [OutputData]
mcall	Sys_MemAlloc, ((1 shl MAX_CODE_SIZE)*sALPH)
xchg    eax, ebx 
xor	eax, eax
mov	[OutputSize], eax
mov	[BitShift], eax
mov	[OutputDWord], eax
@@1000:
mov	[CodeSize], 9
mov	[MaxCode], 512
mov	[FreeCode], (CODE_EOI + 1)
xor	ecx,ecx
@@1100:
mov	word ptr [ebx + ecx * 8 + ALPH_Brother], NO_BROTHER
mov	word ptr [ebx + ecx * 8 + ALPH_Child], NO_CHILD
mov	[ebx + ecx * 8 + ALPH_Character], cl
inc	cl
jnz	@@1100
dec	[InputSize]
js	@@9000
xor	eax, eax
lodsb
mov	[CurrentCode], eax
@@2000:
dec	[InputSize]
js	@@9000
xor	eax, eax
lodsb
mov	[CurrentChar], eax
mov	ecx, [CurrentCode]
xor	eax, eax
mov	ax, word ptr [ebx + ecx * 8 + ALPH_Child]
cmp	eax, NO_CHILD
je	@@3000
mov	edx, [CurrentChar]
@@2100:
cmp	[ebx + eax * 8 + ALPH_Character], dl
je	@@2200
xchg	eax, ecx
xor	eax, eax
mov	ax, word ptr [ebx + ecx * 8 + ALPH_Brother]
cmp	eax, NO_BROTHER
je	@@3000
jmp	@@2100
@@2200:
mov	[CurrentCode], eax
jmp	@@2000
@@3000:
call	@@WriteCurrentCode
@@3100:
mov	edx, [FreeCode]
cmp	edx, [MaxCode]
je	@@4000
inc	[FreeCode]
cmp	eax, NO_CHILD
jne	@@3200
mov	[ebx + ecx * 8 + ALPH_Child], dx
jmp	@@3300
@@3200:
mov	[ebx + ecx * 8 + ALPH_Brother], dx
@@3300:
mov	eax, [CurrentChar]
mov	[CurrentCode], eax
mov	[ebx + edx * 8 + ALPH_Character], al
mov	word ptr [ebx + edx * 8 + ALPH_Child], NO_CHILD
mov	word ptr [ebx + edx * 8 + ALPH_Brother], NO_BROTHER
jmp	@@2000
@@4000:
cmp	[CodeSize], MAX_CODE_SIZE
je	@@4100
inc	[CodeSize]
shl	[MaxCode], 1
jmp	@@3100
@@4100:
dec	esi
dec	[InputSize]
mov	[CurrentCode], CODE_CLEAR
call	@@WriteCurrentCode
jmp	@@1000
@@9000:
call	@@WriteCurrentCode
mov	[CurrentCode], CODE_EOI
call	@@WriteCurrentCode
call	@@WriteCurrentCode
call	@@WriteCurrentCode
mcall	Sys_MemFree, ebx

push	[FreeCode]
push	[CodeSize]
pushstr "codesize = %i, freecode = %i"
call	Sys_LogPrintf
add	esp, 8

popad
mov	eax, [OutputSize]
ret
@@WriteCurrentCode:
mpush	eax, ecx
mov	eax, [CurrentCode]
mov	ecx, [BitShift]
shl	eax, cl
or	[OutputDWord], eax
add	ecx, [CodeSize]
mov	[BitShift], ecx
sub	ecx, 16
js	@@9900
mov	[BitShift], ecx
xor	eax, eax
xchg	eax, [OutputDWord]
xchg	al, ah
stosw
add	[OutputSize], 2
neg	ecx
add	ecx, [CodeSize]
mov	eax, [CurrentCode]
shr	eax, cl
or	[OutputDWord], eax
@@9900:
mpop	ecx, eax
retn
LZW_Compress endp
	
Main proc
local OutputFileName[128]:byte,
	FindData[tWIN32_FIND_DATA],
	SearchHandle,
	InputFileData, InputFileSize,
	OutputFileData, OutputSize,
	CompressionRate
call	Sys_Create
lea	eax, [FindData]
push	eax
pushstr "*.raw"
call	[FindFirstFileA]
mov	[SearchHandle], eax
cmp	eax, -1
je	@@9000
@@1000:
lea	esi, [FindData+WIN32_FIND_DATA_cFileName]
lea	edi, [OutputFileName]
mcall	Sys_LogPrintf, esi
mcall	Sys_StrCpy, edi, esi
mcall	Sys_StrLen, edi
mov	byte ptr [edi + eax - 3], 'l'
mov	byte ptr [edi + eax - 2], 'z'
mov	byte ptr [edi + eax - 1], 'w'
lea	eax, [InputFileSize]
mcall	Sys_FileLoad, esi, eax
mov	[InputFileData], eax
mcall	Sys_MemAlloc, [InputFileSize]
mov	[OutputFileData], eax
mcall 	LZW_Compress,[OutputFileData],[InputFileData],[InputFileSize]
mov	[OutputSize], eax
mcall	Sys_FileSave, edi, [OutputFileData], [OutputSize]
mcall	Sys_MemFree, [InputFileData]
mcall	Sys_MemFree, [OutputFileData]
fild	[InputFileSize]
fisub	[OutputSize]
fidiv	[InputFileSize]
fimul	[v_100]
fistp	[CompressionRate]
push	[CompressionRate]
push	[OutputSize]
push	[InputFileSize]
pushstr "%i => %i  (%i %%)"
call	Sys_LogPrintf
add	esp, 12
@@8000:
lea	eax, [FindData]
mcall	[FindNextFileA], [SearchHandle], eax
test	eax, eax
jnz	@@1000
mcall	[FindClose], [SearchHandle]
@@9000:
call	Sys_Release
Main endp
v_100 dd 100
end Main

